/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/binding/ArrayObjectBinding.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.binding;

import org.apache.commons.cli2.CommandLine;
import org.apache.commons.cli2.Option;

import com.netapp.common.cli.CliParameter;
import com.netapp.common.cli.validator.ValidationException;
import com.netapp.common.cli.validator.ValidatorType;

public class ArrayObjectBinding extends ObjectBinding {

    public ArrayObjectBinding(Class<?> type, CliParameter cliParameter, Option option) {
        super(type, cliParameter, option);
        assert type.isAssignableFrom(String[].class) : "Collection parameter only supports String[] and its superclasses";
    }

    @Override
    protected void validate(CommandLine commandLine) throws ValidationException {
        for (ValidatorType validatorType : this.getCliParameter().validators()) {
            validatorType.getValidator().validate(this, commandLine);
        }
    }

    @Override
    @SuppressWarnings("unchecked")
    public Object doHydrate(CommandLine commandLine) throws ValidationException {
        return commandLine.getValues(this.getOption()).toArray(new String[0]);
    }

}
