/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/credentials/CredentialKey.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.credentials;

import java.util.Arrays;

import javax.xml.bind.annotation.XmlType;

/**
 * A credential key is an array of strings defined by the application. This allows
 * each application to define its own type of key information without putting a 
 * larger burden on the framework.
 * 
 * @author joshb
 *
 */
@XmlType
public class CredentialKey {
    private String[] key;

    public CredentialKey() {
    }

    public CredentialKey(String... key) {
        setKey(key);
    }
    
    public String[] getKey() {
        return key;
    }

    public void setKey(String... key) {
        this.key = key;
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof CredentialKey)) {
            return false;
        }

        CredentialKey other = (CredentialKey) obj;
        return Arrays.equals(getKey(), other.getKey());
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(getKey());
    }

}
