/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/credentials/CredentialValidator.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.credentials;

/**
 * Defines the credential validation interface that an application may support 
 * in order for passwords to be validated before being persisted.
 * 
 * @author joshb
 *
 */
public interface CredentialValidator {
    
    /**
     * Attempts to validate the credential.
     * 
     * @param credential
     * @return true if validated
     */
    boolean isValid(Credential credential);
    
    /**
     * Defines what type of credential is supported by this validator. The
     * type is case insensitive.
     * 
     * @return Type of credential supported by this validator
     */
    String getType();
}
