/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/credentials/service/CredentialServiceConstants.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.credentials.service;

import com.netapp.common.util.ConfigProperty;

public interface CredentialServiceConstants {

    /**
     * Path to the servers private PKCS8 key file.
     */
    ConfigProperty<String> SERVER_PRIVATE_KEY_PATH = ConfigProperty.stringProperty("credential.asymmetric.server.private.path");
    
    /**
     * The servers encryption algorithm to use when retrieving password from the client.
     * 
     * Defaults to RSA.
     */
    ConfigProperty<String> SERVER_ENCRYPTION_ALGORITHM = ConfigProperty.stringProperty("credential.asymmetric.server.algorithm", "RSA");
    
    /**
     * Path to the clients public X509 cert
     */
    ConfigProperty<String> CLIENT_PUBLIC_KEY_PATH = ConfigProperty.stringProperty("credential.asymmetric.client.public.path");
    
    /**
     * The clients encryption algorithm to use when sending the password back to the client.
     * 
     * Defaults to RSA.
     */
    ConfigProperty<String> CLIENT_ENCRYPTION_ALGORITHM = ConfigProperty.stringProperty("credential.asymmetric.client.algorithm", "RSA");
    
    /**
     * Version number for the release of the build
     */
    ConfigProperty<String> RELEASE_VERSION = ConfigProperty.stringProperty("credential.service.version.release", "1.1.0");

    /**
     * Version number for the interface itself
     */
    ConfigProperty<String> INTERFACE_VERSION = ConfigProperty.stringProperty("credential.service.version.interface", "1.0.0");
}
