/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/encryption/StringCipher.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.encryption;

/**
 * Interface for ciphers which can encrypt a string.
 * The encrypted string should be armored in some way to
 * produce a printable string from the input.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public interface StringCipher {
    /**
     * Encrypt  an array of bytes.
     * @param plaintext plaintext
     * @return encrypted output
     */
    String encrypt(String plaintext);

    /**
     * Decrypt an array of bytes
     * @param encrypted encrypted input 
     * @return plaintext output
     */
    String decrypt(String encrypted);

}