/*
 * $Id$
 * 
 * Copyright (c) 2008 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.execution;

import com.netapp.common.util.CollectionUtils;

/**
 * @author claird
 * @version $Revision: #2 $ $Date: Jul 2, 2008 $
 */
class UnixSshShellCommandTransformer extends ShellCommandTransformer {

    protected String host;
    
    public UnixSshShellCommandTransformer(String host) {
        super();
        this.host = host;
    }

    public UnixSshShellCommandTransformer(ShellCommandTransformer shellCommandTransformer, String host) {
        super(shellCommandTransformer);
        this.host = host;
    }

    /**
     * @see com.netapp.common.execution.ShellCommandTransformer#performTransformation(com.netapp.common.execution.ShellRunnable)
     */
    @Override
    protected ShellRunnable performTransformation(ShellRunnable shellCommand) {
        ShellRunnable remoteCommand = shellCommand.transformInto(CollectionUtils.prepend(shellCommand.getArgumentList().toArray(new String[0]), "cd", "`pwd`" , "\\;"));
        ShellRunnable sshCommand = remoteCommand.transformInto("ssh", this.host, createQuotedCommandString(remoteCommand));
        
        return new StackedShellCommand(sshCommand, shellCommand);
    }
}
