/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/ClientAccessibleErrorContainer.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow;

/**
 * Extended OperationResult classes should implement this interface if
 * error objects (ClientAccessibleErrors) need to be returned to
 * the client.
 * 
 * @see ClientAccessibleErrorProvider
 * 
 * @author philipc
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public interface ClientAccessibleErrorContainer<T> {
    
    /**
     * Called by the client to obtain the client accessible error.
     * 
     * @return the client accessible error
     */
    T getClientAccessibleError();
    
    /**
     * Called by the workflow engine to set the client accessible
     * error obtained from a ClientAccessibleErrorProvider
     * 
     * @param clientAccessibleError
     */
    void setClientAccessibleError(T clientAccessibleError);

}
