/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/OperationId.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow;

import java.io.Serializable;

import com.netapp.common.util.GUID;

/**
 * Thin wrapper over GUID to represent Operation Ids.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class OperationId implements Comparable<OperationId>, Serializable {
    private GUID id;
    
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    public OperationId() {
        this.id = new GUID();
    }
    
    public OperationId(String id) {
        this.id = new GUID(id);
    }
    
    public static boolean isId(String id) {
        return GUID.isId(id);
    }
    
    public String getId() {
        return this.id.toString();
    }

    @Override
    public String toString() {
        return this.id.toString();
    }
    
    @Override
    public int hashCode() {
        return this.id.hashCode();
    }
    
    @Override
    public boolean equals(Object arg0) {
        return this.id.equals(((OperationId)arg0).id);
    }
    public int compareTo(OperationId arg0) {
        return this.id.compareTo(arg0.id);
    }
}
