/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/soap/WorkflowBindingHandler.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow.soap;

/**
 * Defines the type of workflow binding handlers to define. These handlers are used
 * to bind data to workflow registers outside of the standard way of defining a 
 * variable on a method.
 * 
 * @author josh
 *
 */
public interface WorkflowBindingHandler {
    
    /**
     * Determine if the handler can process the user defined type.
     * 
     * @param type user defined type
     * @return true if the handler can process the type; otherwise false
     */
    boolean canHandleType(String type);
    
    /**
     * Return the value for the supplied name. 
     * 
     * @param name
     * @return
     */
    String getValue(String name);
}
