/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/soap/WorkflowContextParam.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow.soap;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Defines the header name to retrieve and register to store it in. The type
 * field maps to one of the WorkflowBindingHandlers defined for the WorkflowBindingFactory.
 * 
 * @author josh
 *
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
@Documented
public @interface WorkflowContextParam {
    /**
     * Header name.
     * 
     * @return
     */
    String name();
    
    /**
     * Register to store it into
     * 
     * @return
     */
    String register();
    
    /**
     * Type of WorkflowBindingHandler
     * 
     * @return
     */
    String type();
}
