/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/linux/smbios/BasicStructuredHeader.java#1 $
 * 
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.platform.linux.smbios;

import java.io.IOException;
import java.io.RandomAccessFile;

final class BasicStructuredHeader {
    public static final int SYSTEM_INFORMATION_TYPE = 1;
    public static final int HEADER_IN_BYTES         = 4;

    private int             type;                       // byte
    private int             length;                     // byte
    private int             handle;                     // WORD, 2 bytes

    protected BasicStructuredHeader() {
    }

    /**
     * Read the structured header information from the current position of the
     * file
     * 
     * @param file
     * @return
     */
    public static BasicStructuredHeader read(RandomAccessFile file) throws IOException {
        BasicStructuredHeader header = new BasicStructuredHeader();

        header.setType(file.read());
        header.setLength(file.read());
        header.setHandle(file.readShort());

        return header;
    }

    public int getType() {
        return type;
    }

    protected void setType(int type) {
        this.type = type;
    }

    public int getLength() {
        return length;
    }

    protected void setLength(int length) {
        this.length = length;
    }

    public int getHandle() {
        return handle;
    }

    protected void setHandle(int handle) {
        this.handle = handle;
    }

}
