/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/windows/FileSystemNative.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.platform.windows;

import com.netapp.common.platform.FileOwner;
import com.netapp.common.platform.FileSecurityDescriptor;
import com.netapp.common.platform.JNIException;

public interface FileSystemNative {
    GroupImpl getGroupFromGroupname(String groupname) throws JNIException;
    
    UserImpl getUserFromUsername(String username) throws JNIException;
    
    FileSecurityDescriptor getFileSecurityDescriptor(String path) throws JNIException;
    
    /**
     * Set the FileSecurityDescriptor on the given file.
     * Unlike Unix, this effecitvely does a chown() and chmod() in one
     * atomic operation.
     * @param path Path of file to modify
     * @param descriptor new SecurityDescriptor with owner and acl information
     * @return zero on success, windows error code otherwise
     */
    void setFileSecurityDescriptor(String path, FileSecurityDescriptorImpl descriptor) throws JNIException;
    void changeOwner(String path, FileOwner owner) throws JNIException;
    
    boolean canExecute(String path, UserImpl user);
}
