/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/windows/cimv2/Win32Bios.java#1 $
 *
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved. 
 */
package com.netapp.common.platform.windows.cimv2;

import java.util.Date;
import java.util.List;

import com.netapp.common.platform.windows.WMIElement;
import com.netapp.common.platform.windows.WbemObject;

/**
 * WMI Proxy object representing the Win32_Bios class.
 * 
 * @author josh
 *
 */
public interface Win32Bios extends WbemObject {
    @WMIElement("BiosCharacteristics")
    List<Integer> getBiosCharacteristics();
    
    @WMIElement("BIOSVersion")
    List<String> getBiosVersion();
    
    @WMIElement("BuildNumber")
    String getBuildNumber();
    
    @WMIElement("Caption")
    String getCaption();
    
    @WMIElement("CodeSet")
    String getCodeSet();
    
    @WMIElement("CurrentLanguage")
    String getCurrentLanguage();
    
    @WMIElement("Description")
    String getDescription();
    
    @WMIElement("IdentificationCode")
    String getIdentificationCode();
    
    @WMIElement("InstallableLanguages")
    Integer getInstallableLanguages();
    
    @WMIElement("InstallDate")
    Date getInstallDate();
    
    @WMIElement("LanguageEdition")
    String getLanguageEdition();
    
    @WMIElement("ListOfLanguages")
    List<String> getListOfLanguages();
    
    @WMIElement("Manufacturer")
    String getManufacturer();
    
    @WMIElement("Name")
    String getName();
    
    @WMIElement("OtherTargetOS")
    String getOtherTargetOS();
    
    @WMIElement("PrimaryBIOS")
    Boolean getPrimaryBios();
    
    @WMIElement("ReleaseDate")
    Date getReleaseDate();
    
    @WMIElement("SerialNumber")
    String getSerialNumber();
    
    @WMIElement("SMBIOSBIOSVersion")
    String getSmBiosBiosVersion();
    
    @WMIElement("SMBIOSMajorVersion")
    Integer getSmBiosMajorVersion();
    
    @WMIElement("SMBIOSMinorVersion")
    Integer getSmBiosMinorVersion();
    
    @WMIElement("SMBIOSPresent")
    Boolean getSmBiosPresent();
    
    @WMIElement("SoftwareElementID")
    String getSoftwareElementId();
    
    @WMIElement("SoftwareElementState")
    Integer getSoftwareElementState();
    
    @WMIElement("Status")
    String getStatus();
    
    @WMIElement("TargetOperatingSystem")
    Integer getTargetOperatingSystem();
    
    @WMIElement("Version")
    String getVersion();
}
