/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/remote/jvm/JvmLauncherFactoryImpl.java#1 $
 * 
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.remote.jvm;

import java.io.File;

import com.netapp.common.execution.ShellExecutor;

/**
 * @author claird
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class JvmLauncherFactoryImpl implements JvmLauncherFactory {

    protected File javaLauncher;
    
    public JvmLauncherFactoryImpl(String javaLauncherPath) {
        this.javaLauncher = new File(javaLauncherPath);
    }

    /**
     * 
     * @see com.netapp.common.remote.jvm.JvmLauncherFactory#createLocalJvmLauncher(com.netapp.common.execution.ShellExecutor)
     */
    public JvmLauncher createLocalJvmLauncher(ShellExecutor shellExecutor) {
        return new LocalJvmLauncher(shellExecutor, this.javaLauncher);
    }

    /**
     * 
     * @see com.netapp.common.remote.jvm.JvmLauncherFactory#createRemoteJvmLauncher(com.netapp.common.remote.jvm.RemoteJvmLauncherInfo)
     */
    public JvmLauncher createRemoteJvmLauncher(RemoteJvmLauncherInfo remoteJvmLauncherInfo) {
        return new SshJvmLauncher(remoteJvmLauncherInfo, this.javaLauncher);
    }
}
