/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/remote/jvm/SshJvmLauncher.java#1 $
 * 
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.remote.jvm;

import java.io.File;

import com.netapp.common.execution.ShellExecutor;
import com.netapp.common.execution.ShellExecutorFactory;

/**
 * @author claird
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class SshJvmLauncher extends ShellExecutorJvmLauncher implements JvmLauncher {
    private RemoteJvmLauncherInfo remoteJvmLauncherInfo;
    
    public SshJvmLauncher(RemoteJvmLauncherInfo remoteJvmLauncherInfo, File javaLauncher) {
        super(null, javaLauncher);
        this.remoteJvmLauncherInfo = remoteJvmLauncherInfo;
    }

    /**
     * @see com.netapp.common.remote.jvm.ShellExecutorJvmLauncher#launch(com.netapp.common.remote.jvm.JvmLaunchCommand)
     */
    @Override
    public JvmLaunchResult launch(JvmLaunchCommand jvmLaunchCommand) {
        ShellExecutor shellExecutor = createShellExecutor();
        shellExecutor.unsetEnvironmentVariable("DEBUG_PORT");
        setShellExecutor(shellExecutor);
        return super.launch(jvmLaunchCommand);
    }

    protected ShellExecutor createShellExecutor() {
        if (this.remoteJvmLauncherInfo instanceof UserSwitchingRemoteJvmLauncherInfo) {
            UserSwitchingRemoteJvmLauncherInfo userSwitchingRemoteJvmLauncherInfo = (UserSwitchingRemoteJvmLauncherInfo) this.remoteJvmLauncherInfo;
            return ShellExecutorFactory.createUserSwitchingSshShellExecutor(userSwitchingRemoteJvmLauncherInfo.getUser(),
                userSwitchingRemoteJvmLauncherInfo.getHost());
        }
        else {
            return ShellExecutorFactory.createSshShellExecutor(this.remoteJvmLauncherInfo.getHost());
        }
    }

    /**
     * @see com.netapp.common.remote.jvm.JvmLauncher#isRemote()
     */
    public boolean isRemote() {
        return true;
    }  
}
