/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/autozapi/AutoZapiApiFieldGenerator.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator.autozapi;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import com.netapp.common.zapi.parser.Api;
import com.netapp.common.zapi.parser.Api.ApiField;

public class AutoZapiApiFieldGenerator extends AutoZapiFieldGenerator<ApiField> {
    //private static final NALogger logger = NALogger.getLogger(AutoZapiApiFieldGenerator.class);
    
    public AutoZapiApiFieldGenerator(AutoZapiGeneratorFactory generatorFactory, ApiField apiField) {
        super(generatorFactory, apiField);
    }
    
    @Override
    public String getNameGenerated() {
        String nameGenerated = super.getNameGenerated();
        if (nameGenerated != null
                && ((Api) getTarget().getDeclaringType()).hasMultipleFieldsNamed(getTarget().getName())) {
            
            //logger.warn(MsgKey.ZAPI_GENERATOR_API_FIELD_RENAMED, getTarget().getDeclaringType().getName(), getTarget().getName());
            
            String suffix = (getTarget().isInput() ? "Input" : "") + (getTarget().isOutput() ? "Output" : "");
            
            nameGenerated += suffix;
        }
        
        return nameGenerated;
    }

    @Override
    public Set<String> getImports() {
        Set<String> imports = super.getImports();
        
        if (getTarget().isInput()) {
            imports.add(AutoZapiTypeGenerator.ANNOTATION_PACKAGE + ".Input");
        }
        
        if (getTarget().isOutput()) {
            imports.add(AutoZapiTypeGenerator.ANNOTATION_PACKAGE + ".Output");
        }

        return imports;
    }
    
    @Override
    public List<String> getFieldAnnotations() {
        // We want the Input/Output annotation first in the list
        // followed by any generic field annotations
        List<String> list = new ArrayList<String>();
        if (getTarget().isInput()) {
            list.add("Input(\"" + getTarget().getName() + "\")");
        }
        
        if (getTarget().isOutput()) {
            list.add("Output(\"" + getTarget().getName() + "\")");
        }
        list.addAll(super.getFieldAnnotations());
        return list;
    }
    
}
