/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/autozapi/AutoZapiApiGenerator.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator.autozapi;

import java.util.Collection;
import java.util.List;
import java.util.Set;

import com.netapp.common.zapi.parser.Api;
import com.netapp.common.zapi.parser.Field;

public class AutoZapiApiGenerator extends AutoZapiTypeGenerator<Api> {

    public AutoZapiApiGenerator(AutoZapiGeneratorFactory generatorFactory, Api api) {
        super(generatorFactory, api);
    }
    
    @Override
    public Set<String> getImports(Collection<Field> fields) {
        Api api = getTarget();

        Set<String> imports = super.getImports(fields);
        
        imports.add(ANNOTATION_PACKAGE + ".Api");
        imports.add(ANNOTATION_PACKAGE + ".Status");
        imports.add(ANNOTATION_PACKAGE + ".StatusEnum");
        
        if (!api.getErrors().isEmpty()) {
            imports.add(ANNOTATION_PACKAGE + ".Errno");
        }
        
        if (!api.getFamily().isEmpty()) {
            imports.add(ANNOTATION_PACKAGE + ".Family");
        }
        
        return imports;
    }
    
    @Override
    public List<String> getClassAnnotations() {
        Api api = getTarget();
        
        List<String> annotations = super.getClassAnnotations();
        annotations.add("Status(StatusEnum." + api.getStatus() + ")");
        
        if (!api.getErrors().isEmpty()) {
            annotations.add(stringAnnotation("Errno", api.getErrors()));
        }
        
        if (!api.getFamily().isEmpty()) {
            annotations.add(stringAnnotation("Family", api.getFamily()));
        }
        return annotations;
    }
    
}