/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/parser/Errdef.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.parser;

import java.util.Queue;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

import com.netapp.common.logging.NALogger;

/**
 * Represent a ZAPI Error enum / value pair
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class Errdef {
    private static final NALogger logger = NALogger.getLogger(Errdef.class);

    private String name;
    private int code;
    private String desc;
    
    Errdef(String name, int code) {
        this.name = name;
        this.code = code;
    }
    
    public void populate(Queue<Tag> q) {
        logger.internal("Processing Field " + name);
        Tag tag = q.peek();
        while (tag != null) {
            if (tag.is(TagEnum.DESC)) {
                this.setDesc(tag.getValue());
            }
            else {
                break;
            }
            q.poll();
            tag = q.peek();
        }
    }
    
    private void setDesc(String desc) {
        this.desc = desc;
    }
    
    public String getName() {
        return this.name;
    }
    
    public int getCode() {
        return this.code;
    }
    
    public String getDesc() {
        return this.desc;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Errdef)) {
            return false;
            
        }
        Errdef that = (Errdef) obj;
        return new EqualsBuilder()
            .append(this.code, that.code)
            .append(this.name, that.name)
            .isEquals();
    }
    
    @Override
    public int hashCode() {
        return new HashCodeBuilder()
            .append(this.code)
            .append(this.name)
            .toHashCode();
    }

}
